# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `X-Firewall-Auth-Token` for all the firewall methods and `rime-api-key` for all other methods.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: dev@robustintelligence.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GenerativevalidationHttpConnectionSpec(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'url': 'str',
        'http_headers': 'dict(str, str)',
        'endpoint_payload_template': 'str',
        'response_json_path': 'str',
        'http_auth_integration_id': 'RimeUUID',
        'mtls_integration_id': 'RimeUUID'
    }

    attribute_map = {
        'url': 'url',
        'http_headers': 'httpHeaders',
        'endpoint_payload_template': 'endpointPayloadTemplate',
        'response_json_path': 'responseJsonPath',
        'http_auth_integration_id': 'httpAuthIntegrationId',
        'mtls_integration_id': 'mtlsIntegrationId'
    }

    def __init__(self, url=None, http_headers=None, endpoint_payload_template=None, response_json_path=None, http_auth_integration_id=None, mtls_integration_id=None):  # noqa: E501
        """GenerativevalidationHttpConnectionSpec - a model defined in Swagger"""  # noqa: E501
        self._url = None
        self._http_headers = None
        self._endpoint_payload_template = None
        self._response_json_path = None
        self._http_auth_integration_id = None
        self._mtls_integration_id = None
        self.discriminator = None
        self.url = url
        if http_headers is not None:
            self.http_headers = http_headers
        self.endpoint_payload_template = endpoint_payload_template
        self.response_json_path = response_json_path
        if http_auth_integration_id is not None:
            self.http_auth_integration_id = http_auth_integration_id
        if mtls_integration_id is not None:
            self.mtls_integration_id = mtls_integration_id

    @property
    def url(self):
        """Gets the url of this GenerativevalidationHttpConnectionSpec.  # noqa: E501


        :return: The url of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this GenerativevalidationHttpConnectionSpec.


        :param url: The url of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :type: str
        """
        if url is None:
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501

        self._url = url

    @property
    def http_headers(self):
        """Gets the http_headers of this GenerativevalidationHttpConnectionSpec.  # noqa: E501

        HTTP headers that will be sent along with the request payload to the LLM endpoint. These headers can include authentication.  # noqa: E501

        :return: The http_headers of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._http_headers

    @http_headers.setter
    def http_headers(self, http_headers):
        """Sets the http_headers of this GenerativevalidationHttpConnectionSpec.

        HTTP headers that will be sent along with the request payload to the LLM endpoint. These headers can include authentication.  # noqa: E501

        :param http_headers: The http_headers of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :type: dict(str, str)
        """

        self._http_headers = http_headers

    @property
    def endpoint_payload_template(self):
        """Gets the endpoint_payload_template of this GenerativevalidationHttpConnectionSpec.  # noqa: E501

        A string template that will be used to create the json payload sent to the LLM endpoint. This template must contain one and only one variable -- prompt_string. This will be replaced at runtime with the prompt used to send to the model.  # noqa: E501

        :return: The endpoint_payload_template of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :rtype: str
        """
        return self._endpoint_payload_template

    @endpoint_payload_template.setter
    def endpoint_payload_template(self, endpoint_payload_template):
        """Sets the endpoint_payload_template of this GenerativevalidationHttpConnectionSpec.

        A string template that will be used to create the json payload sent to the LLM endpoint. This template must contain one and only one variable -- prompt_string. This will be replaced at runtime with the prompt used to send to the model.  # noqa: E501

        :param endpoint_payload_template: The endpoint_payload_template of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :type: str
        """
        if endpoint_payload_template is None:
            raise ValueError("Invalid value for `endpoint_payload_template`, must not be `None`")  # noqa: E501

        self._endpoint_payload_template = endpoint_payload_template

    @property
    def response_json_path(self):
        """Gets the response_json_path of this GenerativevalidationHttpConnectionSpec.  # noqa: E501

        A json path specifying where in the response json payload we can find the LLM's response response string. Note that the path must point to a string value in the json payload. Whitespace and other special characters can be encoded as unicode (\\u0020). Periods in json fields can be escaped with a backslash.  # noqa: E501

        :return: The response_json_path of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :rtype: str
        """
        return self._response_json_path

    @response_json_path.setter
    def response_json_path(self, response_json_path):
        """Sets the response_json_path of this GenerativevalidationHttpConnectionSpec.

        A json path specifying where in the response json payload we can find the LLM's response response string. Note that the path must point to a string value in the json payload. Whitespace and other special characters can be encoded as unicode (\\u0020). Periods in json fields can be escaped with a backslash.  # noqa: E501

        :param response_json_path: The response_json_path of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :type: str
        """
        if response_json_path is None:
            raise ValueError("Invalid value for `response_json_path`, must not be `None`")  # noqa: E501

        self._response_json_path = response_json_path

    @property
    def http_auth_integration_id(self):
        """Gets the http_auth_integration_id of this GenerativevalidationHttpConnectionSpec.  # noqa: E501


        :return: The http_auth_integration_id of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :rtype: RimeUUID
        """
        return self._http_auth_integration_id

    @http_auth_integration_id.setter
    def http_auth_integration_id(self, http_auth_integration_id):
        """Sets the http_auth_integration_id of this GenerativevalidationHttpConnectionSpec.


        :param http_auth_integration_id: The http_auth_integration_id of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :type: RimeUUID
        """

        self._http_auth_integration_id = http_auth_integration_id

    @property
    def mtls_integration_id(self):
        """Gets the mtls_integration_id of this GenerativevalidationHttpConnectionSpec.  # noqa: E501


        :return: The mtls_integration_id of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :rtype: RimeUUID
        """
        return self._mtls_integration_id

    @mtls_integration_id.setter
    def mtls_integration_id(self, mtls_integration_id):
        """Sets the mtls_integration_id of this GenerativevalidationHttpConnectionSpec.


        :param mtls_integration_id: The mtls_integration_id of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :type: RimeUUID
        """

        self._mtls_integration_id = mtls_integration_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GenerativevalidationHttpConnectionSpec, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GenerativevalidationHttpConnectionSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
